/**
 * @author pastakhov, MusikAnimal and others
 * @license GPL-2.0-or-later
 * @see https://gerrit.wikimedia.org/g/mediawiki/extensions/CodeMirror
 */
import { LanguageSupport } from '@codemirror/language';
/**
 * 获取维基链接建议
 * @param search 搜索字符串
 * @param namespace 命名空间
 */
export type LinkSuggest = (search: string, namespace?: number) => string[] | Promise<string[]>;
export interface MwConfig {
    readonly tags: Record<string, true>;
    readonly tagModes: Record<string, string>;
    urlProtocols: string;
    functionSynonyms: [Record<string, string>, Record<string, unknown>];
    doubleUnderscore: [Record<string, unknown>, Record<string, unknown>];
    variants?: string[];
    img?: Record<string, string>;
    nsid: Record<string, number>;
    permittedHtmlTags?: string[];
    implicitlyClosedHtmlTags?: string[];
    linkSuggest?: LinkSuggest;
}
/**
 * Gets a LanguageSupport instance for the MediaWiki mode.
 * @param config Configuration for the MediaWiki mode
 */
export declare const mediawiki: (config: MwConfig) => LanguageSupport;
/**
 * Gets a LanguageSupport instance for the mixed MediaWiki-HTML mode.
 * @param config Configuration for the MediaWiki mode
 */
export declare const html: (config: MwConfig) => LanguageSupport;
